#!/bin/bash

# Tool for background importing structures.
#
# 2011 Ondrej Cecak <ondrej@cecak.cz>, CVUT FEL
# v1.0

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.

# configuration
pathToImport="/home/oc/job/fel/X36DIP/develop/import/testing/try/"

if [ -e ~/cron-bin/stamps/nadb-worker ]; then
  echo "ERROR: Stamp exists."
  exit 1
fi

touch ~/cron-bin/stamps/nadb-worker

count="`echo "SELECT COUNT(*) FROM importQueue;" | psql -q -Unadb | grep -v row | grep '[0-9]' | sed 's/ *//'`"

if [ $count -gt 0 ]; then
  while [ $count -gt 0 ]; do
    echo "UPDATE import SET active=1;" | psql -q -Unadb 
  
    echo "SELECT pdbCode FROM importQueue LIMIT 1;" | psql -q -Unadb | head -n3 | tail -n1 | sed 's/ *//' | while read pdbCode; do
      echo "DELETE FROM importQueue WHERE pdbCode='$pdbCode';" | psql -q -Unadb
      cd $pathToImport || exit 1
      ./import.py $pdbCode | tee -a $pdbCode.log
    done
   
    echo "UPDATE import SET done=done+1;" | psql -q -Unadb 
  
    count="`echo "SELECT COUNT(*) FROM importQueue;" | psql -q -Unadb | grep -v row | grep '[0-9]' | sed 's/ *//'`"
  done

  echo "UPDATE import SET active=0,finished=NOW();" | psql -q -Unadb 
fi

rm -f ~/cron-bin/stamps/nadb-worker

